#pragma rtGlobals=1		// Use modern global access method.

//2/18/11 - replaced the SwapDataPoints() function with the builtin reverse operation.  This also fixes
//                    1 point offset bug that SwapDataPoints() had. -J. Gutow

Function Readjdx(filenumber, datapath, filename)
	string filename, datapath
	variable filenumber
	variable firstx, lastx, delta, points, pointsswitch, whichpoint, xmult, ymult
	string nameforwave, executestring, title, version, user, S_date, xunits, yunits, resolution, data_type, str
	string key
	points = -1 //used to tell when it has been set.  At this point we can make our wave
	pointsswitch = 0
	whichpoint=0
	do
		FReadLine filenumber, str
		key = str[0,1]
		key=num2str(str2num(key))  //will give NaN if not a number, will send to header routine
		strswitch(key)
			case "NaN":
				ReadDXHeader(str, firstx, lastx, delta, points, xmult, ymult, xunits, yunits)
				If ((pointsswitch==0) && (points!=-1))
					make /O/n=(points) DataWave
					wave DataWave = DataWave
					pointsswitch =1 //set so this will not be executed again
				endif
				break
			default:
				ReadDXData(str, whichpoint, ymult, DataWave)
				break
		endswitch
	while (!stringmatch(str,"*##END=*"))
	close filenumber
	
	//store all the information in the wave scales or notes
	SetScale/I x firstx,lastx, xunits,DataWave
	SetScale d 0,100,yunits,DataWave

	//Now check to see that the x values increase with increasing point value.  If they don't than swap
	//all the points end over end.
	If (firstx > lastx) //we need to flip the wave to make sure some IGOR functions won't be confused.
		reverse DataWave
	endif

	//now let's rename the wave
	nameforwave=FileNameOnly(Filename)
	executestring = "duplicate/O DataWave,'"+nameforwave+"'"
	Execute executestring
		
	//Cleanup
	print "data loaded into wave: ", nameforwave
	killwaves DataWave

end

function ReadDXHeader(Line, firstx, lastx, delta, points, xmult, ymult, xunits,yunits)
	string Line, &xunits,&yunits
	variable &firstx, &lastx, &delta, &points, &xmult, &ymult
	
	if (stringmatch(Line, "*NPOINTS*"))
		points = str2num(Line[(strsearch(Line, "=",0)+1), strlen(Line)])
	endif
	if (stringmatch(Line, "*YFACTOR*"))
		ymult= str2num(Line[(strsearch(Line, "=",0)+1), strlen(Line)])
	endif
	if (stringmatch(Line, "*YUNITS*"))
		yunits = Line[(strsearch(Line, "=",0)+1), (strlen(Line)-1)]
	endif
	if (stringmatch(Line, "*XUNITS*"))
		xunits =Line[(strsearch(Line, "=",0)+1), (strlen(Line)-1)]
	endif
	if (stringmatch(Line, "*DELTAX*"))
		delta = str2num(Line[(strsearch(Line, "=",0)+1), strlen(Line)])
	endif
	if (stringmatch(Line, "*FIRSTX*"))
		firstx = str2num(Line[(strsearch(Line, "=",0)+1), strlen(Line)])
	endif
	if (stringmatch(Line, "*LASTX*"))
		lastx = str2num(Line[(strsearch(Line, "=",0)+1), strlen(Line)])
	endif
	
	
end

function ReadDXData(Line, whichpoint, ymult, DataWave)
	string Line
	variable &whichpoint, ymult
	wave DataWave
	variable space1,space2 //used to keep track of where we are in the string we're parsing
	
	space1=strsearch(Line, " ",0)
	do
		space2=strsearch(line, " ",(space1+1))
		if (space2==-1)
			space2=strlen(Line)
		endif
		DataWave[whichpoint]=ymult*str2num(line[space1,space2])
		space1=space2
		whichpoint=whichpoint+1
	while (space2 < strlen(Line))
end